from log import log
from rule import Rule
from symbols import Symbol


class Rules(list):
    def __init__(self, rules=None):
        super().__init__()
        self.rule_set = set()

        # TODO: tohle chce přesunout do __add__ (a to vytvořit!)
        if rules is not None:
            for rule in rules:
                if isinstance(rule, str):
                    rule = Rule(rule)
                if rule in self.rule_set:
                    log.warning('duplicate rule %s', rule)
                else:
                    self.append(rule)
                    self.rule_set.add(rule)

    def insert_into_all(self, inserted_symbol, before=False, inside=True,
                          after=False, position=None, repeat_self=False,
                          update_left=None):
        if isinstance(inserted_symbol, str):
            inserted_symbol = Symbol(inserted_symbol)
        if isinstance(update_left, str):
            update_left = Symbol(update_left)
        for rule in self:
            if repeat_self:
                yield rule
            yield rule.insert_symbol(
                inserted_symbol, before, inside, after, position, update_left)
